<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (49)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="recursion-and-stack">Recursion and stack</h1>
    <p>Let’s return to functions and study them more in-depth.</p>
    <p>Our first topic will be <em>recursion</em>.</p>
    <p>
      If you are not new to programming, then it is probably familiar and you
      could skip this chapter.
    </p>
    <p>
      Recursion is a programming pattern that is useful in situations when a
      task can be naturally split into several tasks of the same kind, but
      simpler. Or when a task can be simplified into an easy action plus a
      simpler variant of the same task. Or, as we’ll see soon, to deal with
      certain data structures.
    </p>
    <p>
      When a function solves a task, in the process it can call many other
      functions. A partial case of this is when a function calls
      <em>itself</em>. That’s called <em>recursion</em>.
    </p>
    <h2 id="two-ways-of-thinking">Two ways of thinking</h2>
    <p>
      For something simple to start with – let’s write a function
      <code>pow(x, n)</code> that raises <code>x</code> to a natural power of
      <code>n</code>. In other words, multiplies <code>x</code> by itself
      <code>n</code> times.
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="at">pow</span>(<span class="dv">2</span><span class="op">,</span> <span class="dv">2</span>) <span class="op">=</span> <span class="dv">4</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="at">pow</span>(<span class="dv">2</span><span class="op">,</span> <span class="dv">3</span>) <span class="op">=</span> <span class="dv">8</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="at">pow</span>(<span class="dv">2</span><span class="op">,</span> <span class="dv">4</span>) <span class="op">=</span> <span class="dv">16</span></a></code></pre>
    </div>
    <p>There are two ways to implement it.</p>
    <ol type="1">
      <li>
        <p>Iterative thinking: the <code>for</code> loop:</p>
        <p>```js run function pow(x, n) { let result = 1;</p>
        <p>
          // multiply result by x n times in the loop for (let i = 0; i &lt; n;
          i++) { result *= x; }
        </p>
        <p>return result; }</p>
        <p>alert(pow(2, 3)); // 8 ```</p>
      </li>
      <li>
        <p>Recursive thinking: simplify the task and call self:</p>
        <p>
          ```js run function pow(x, n) { if (n == 1) { return x; } else { return
          x * pow(x, n - 1); } }
        </p>
        <p>alert(pow(2, 3)); // 8 ```</p>
      </li>
    </ol>
    <p>Please note how the recursive variant is fundamentally different.</p>
    <p>
      When <code>pow(x, n)</code> is called, the execution splits into two
      branches:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1">              <span class="cf">if</span> n<span class="op">==</span><span class="dv">1</span>  <span class="op">=</span> x</a>
<a class="sourceLine" id="cb2-2" title="2">             /</a>
<a class="sourceLine" id="cb2-3" title="3"><span class="at">pow</span>(x<span class="op">,</span> n) <span class="op">=</span></a>
<a class="sourceLine" id="cb2-4" title="4">             \</a>
<a class="sourceLine" id="cb2-5" title="5">              <span class="cf">else</span>     <span class="op">=</span> x <span class="op">*</span> <span class="at">pow</span>(x<span class="op">,</span> n <span class="op">-</span> <span class="dv">1</span>)</a></code></pre>
    </div>
    <ol type="1">
      <li>
        If <code>n == 1</code>, then everything is trivial. It is called
        <em>the base</em> of recursion, because it immediately produces the
        obvious result: <code>pow(x, 1)</code> equals <code>x</code>.
      </li>
      <li>
        Otherwise, we can represent <code>pow(x, n)</code> as
        <code>x * pow(x, n - 1)</code>. In maths, one would write
        <code>x<sup>n</sup> = x * x<sup>n-1</sup></code
        >. This is called *a recursive step*: we transform the task into a
        simpler action (multiplication by <code>x</code>) and a simpler call of
        the same task (<code>pow</code> with lower <code>n</code>). Next steps
        simplify it further and further until <code>n</code> reaches
        <code>1</code>.
      </li>
    </ol>
    <p>
      We can also say that <code>pow</code>
      <em>recursively calls itself</em> till <code>n == 1</code>.
    </p>
    <figure>
      <img src="recursion-pow.svg" alt="recursive diagram of pow" />
      <figcaption>recursive diagram of pow</figcaption>
    </figure>
    <p>
      For example, to calculate <code>pow(2, 4)</code> the recursive variant
      does these steps:
    </p>
    <ol type="1">
      <li><code>pow(2, 4) = 2 * pow(2, 3)</code></li>
      <li><code>pow(2, 3) = 2 * pow(2, 2)</code></li>
      <li><code>pow(2, 2) = 2 * pow(2, 1)</code></li>
      <li><code>pow(2, 1) = 2</code></li>
    </ol>
    <p>
      So, the recursion reduces a function call to a simpler one, and then – to
      even more simpler, and so on, until the result becomes obvious.
    </p>
    <p>
      ````smart header=“Recursion is usually shorter” A recursive solution is
      usually shorter than an iterative one.
    </p>
    <p>
      Here we can rewrite the same using the conditional operator
      <code>?</code> instead of <code>if</code> to make
      <code>pow(x, n)</code> more terse and still very readable:
    </p>
    <p>
      <code
        >js run function pow(x, n) { return (n == 1) ? x : (x * pow(x, n - 1));
        }</code
      >
      ````
    </p>
    <p>
      The maximal number of nested calls (including the first one) is called
      <em>recursion depth</em>. In our case, it will be exactly <code>n</code>.
    </p>
    <p>
      The maximal recursion depth is limited by JavaScript engine. We can rely
      on it being 10000, some engines allow more, but 100000 is probably out of
      limit for the majority of them. There are automatic optimizations that
      help alleviate this (“tail calls optimizations”), but they are not yet
      supported everywhere and work only in simple cases.
    </p>
    <p>
      That limits the application of recursion, but it still remains very wide.
      There are many tasks where recursive way of thinking gives simpler code,
      easier to maintain.
    </p>
    <h2 id="the-execution-context-and-stack">
      The execution context and stack
    </h2>
    <p>
      Now let’s examine how recursive calls work. For that we’ll look under the
      hood of functions.
    </p>
    <p>
      The information about the process of execution of a running function is
      stored in its <em>execution context</em>.
    </p>
    <p>
      The
      <a href="https://tc39.github.io/ecma262/#sec-execution-contexts"
        >execution context</a
      >
      is an internal data structure that contains details about the execution of
      a function: where the control flow is now, the current variables, the
      value of <code>this</code> (we don’t use it here) and few other internal
      details.
    </p>
    <p>
      One function call has exactly one execution context associated with it.
    </p>
    <p>When a function makes a nested call, the following happens:</p>
    <ul>
      <li>The current function is paused.</li>
      <li>
        The execution context associated with it is remembered in a special data
        structure called <em>execution context stack</em>.
      </li>
      <li>The nested call executes.</li>
      <li>
        After it ends, the old execution context is retrieved from the stack,
        and the outer function is resumed from where it stopped.
      </li>
    </ul>
    <p>Let’s see what happens during the <code>pow(2, 3)</code> call.</p>
    <h3 id="pow2-3">pow(2, 3)</h3>
    <p>
      In the beginning of the call <code>pow(2, 3)</code> the execution context
      will store variables: <code>x = 2, n = 3</code>, the execution flow is at
      line <code>1</code> of the function.
    </p>
    <p>We can sketch it as:</p>
    <ul class="function-execution-context-list">
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 3, at line 1 }</span
        >
        <span class="function-execution-context-call">pow(2, 3)</span>
      </li>
    </ul>
    <p>
      That’s when the function starts to execute. The condition
      <code>n == 1</code> is falsy, so the flow continues into the second branch
      of <code>if</code>:
    </p>
    <p>
      ```js run function pow(x, n) { if (n == 1) { return x; } else {
      <em>!</em> return x * pow(x, n - 1); <em>/!</em> } }
    </p>
    <p>alert( pow(2, 3) ); ```</p>
    <p>The variables are same, but the line changes, so the context is now:</p>
    <ul class="function-execution-context-list">
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 3, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 3)</span>
      </li>
    </ul>
    <p>
      To calculate <code>x * pow(x, n - 1)</code>, we need to make a subcall of
      <code>pow</code> with new arguments <code>pow(2, 2)</code>.
    </p>
    <h3 id="pow2-2">pow(2, 2)</h3>
    <p>
      To do a nested call, JavaScript remembers the current execution context in
      the <em>execution context stack</em>.
    </p>
    <p>
      Here we call the same function <code>pow</code>, but it absolutely doesn’t
      matter. The process is the same for all functions:
    </p>
    <ol type="1">
      <li>The current context is “remembered” on top of the stack.</li>
      <li>The new context is created for the subcall.</li>
      <li>
        When the subcall is finished – the previous context is popped from the
        stack, and its execution continues.
      </li>
    </ol>
    <p>
      Here’s the context stack when we entered the subcall
      <code>pow(2, 2)</code>:
    </p>
    <ul class="function-execution-context-list">
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 2, at line 1 }</span
        >
        <span class="function-execution-context-call">pow(2, 2)</span>
      </li>
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 3, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 3)</span>
      </li>
    </ul>
    <p>
      The new current execution context is on top (and bold), and previous
      remembered contexts are below.
    </p>
    <p>
      When we finish the subcall – it is easy to resume the previous context,
      because it keeps both variables and the exact place of the code where it
      stopped.
    </p>
    <pre
      class="smart"
    ><code>Here in the picture we use the word &quot;line&quot;, as in our example there&#39;s only one subcall in line, but generally a single line of code may contain multiple subcalls, like `pow(…) + pow(…) + somethingElse(…)`.

So it would be more precise to say that the execution resumes &quot;immediately after the subcall&quot;.</code></pre>
    <h3 id="pow2-1">pow(2, 1)</h3>
    <p>
      The process repeats: a new subcall is made at line <code>5</code>, now
      with arguments <code>x=2</code>, <code>n=1</code>.
    </p>
    <p>
      A new execution context is created, the previous one is pushed on top of
      the stack:
    </p>
    <ul class="function-execution-context-list">
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 1, at line 1 }</span
        >
        <span class="function-execution-context-call">pow(2, 1)</span>
      </li>
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 2, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 2)</span>
      </li>
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 3, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 3)</span>
      </li>
    </ul>
    <p>
      There are 2 old contexts now and 1 currently running for
      <code>pow(2, 1)</code>.
    </p>
    <h3 id="the-exit">The exit</h3>
    <p>
      During the execution of <code>pow(2, 1)</code>, unlike before, the
      condition <code>n == 1</code> is truthy, so the first branch of
      <code>if</code> works:
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">function</span> <span class="at">pow</span>(x<span class="op">,</span> n) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="cf">if</span> (n <span class="op">==</span> <span class="dv">1</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb4-4" title="4">    <span class="cf">return</span> x<span class="op">;</span></a>
<a class="sourceLine" id="cb4-5" title="5"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb4-6" title="6"><span class="ss">  } else {</span></a>
<a class="sourceLine" id="cb4-7" title="7"><span class="ss">    return x </span><span class="sc">*</span><span class="ss"> pow</span><span class="sc">(</span><span class="ss">x, n - 1</span><span class="sc">)</span><span class="ss">;</span></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="ss">  }</span></a>
<a class="sourceLine" id="cb4-9" title="9"><span class="ss">}</span></a></code></pre>
    </div>
    <p>
      There are no more nested calls, so the function finishes, returning
      <code>2</code>.
    </p>
    <p>
      As the function finishes, its execution context is not needed anymore, so
      it’s removed from the memory. The previous one is restored off the top of
      the stack:
    </p>
    <ul class="function-execution-context-list">
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 2, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 2)</span>
      </li>
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 3, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 3)</span>
      </li>
    </ul>
    <p>
      The execution of <code>pow(2, 2)</code> is resumed. It has the result of
      the subcall <code>pow(2, 1)</code>, so it also can finish the evaluation
      of <code>x * pow(x, n - 1)</code>, returning <code>4</code>.
    </p>
    <p>Then the previous context is restored:</p>
    <ul class="function-execution-context-list">
      <li>
        <span class="function-execution-context"
          >Context: { x: 2, n: 3, at line 5 }</span
        >
        <span class="function-execution-context-call">pow(2, 3)</span>
      </li>
    </ul>
    <p>When it finishes, we have a result of <code>pow(2, 3) = 8</code>.</p>
    <p>The recursion depth in this case was: <strong>3</strong>.</p>
    <p>
      As we can see from the illustrations above, recursion depth equals the
      maximal number of context in the stack.
    </p>
    <p>
      Note the memory requirements. Contexts take memory. In our case, raising
      to the power of <code>n</code> actually requires the memory for
      <code>n</code> contexts, for all lower values of <code>n</code>.
    </p>
    <p>A loop-based algorithm is more memory-saving:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">function</span> <span class="at">pow</span>(x<span class="op">,</span> n) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="kw">let</span> result <span class="op">=</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-3" title="3"></a>
<a class="sourceLine" id="cb5-4" title="4">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-5" title="5">    result <span class="op">*=</span> x<span class="op">;</span></a>
<a class="sourceLine" id="cb5-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-7" title="7"></a>
<a class="sourceLine" id="cb5-8" title="8">  <span class="cf">return</span> result<span class="op">;</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      The iterative <code>pow</code> uses a single context changing
      <code>i</code> and <code>result</code> in the process. Its memory
      requirements are small, fixed and do not depend on <code>n</code>.
    </p>
    <p>
      <strong
        >Any recursion can be rewritten as a loop. The loop variant usually can
        be made more effective.</strong
      >
    </p>
    <p>
      …But sometimes the rewrite is non-trivial, especially when function uses
      different recursive subcalls depending on conditions and merges their
      results or when the branching is more intricate. And the optimization may
      be unneeded and totally not worth the efforts.
    </p>
    <p>
      Recursion can give a shorter code, easier to understand and support.
      Optimizations are not required in every place, mostly we need a good code,
      that’s why it’s used.
    </p>
    <h2 id="recursive-traversals">Recursive traversals</h2>
    <p>Another great application of the recursion is a recursive traversal.</p>
    <p>
      Imagine, we have a company. The staff structure can be presented as an
      object:
    </p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">let</span> company <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="dt">sales</span><span class="op">:</span> [</a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="op">{</span></a>
<a class="sourceLine" id="cb6-4" title="4">      <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;John&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-5" title="5">      <span class="dt">salary</span><span class="op">:</span> <span class="dv">1000</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-6" title="6">    <span class="op">},</span></a>
<a class="sourceLine" id="cb6-7" title="7">    <span class="op">{</span></a>
<a class="sourceLine" id="cb6-8" title="8">      <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Alice&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-9" title="9">      <span class="dt">salary</span><span class="op">:</span> <span class="dv">1600</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-10" title="10">    <span class="op">},</span></a>
<a class="sourceLine" id="cb6-11" title="11">  ]<span class="op">,</span></a>
<a class="sourceLine" id="cb6-12" title="12"></a>
<a class="sourceLine" id="cb6-13" title="13">  <span class="dt">development</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-14" title="14">    <span class="dt">sites</span><span class="op">:</span> [</a>
<a class="sourceLine" id="cb6-15" title="15">      <span class="op">{</span></a>
<a class="sourceLine" id="cb6-16" title="16">        <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Peter&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-17" title="17">        <span class="dt">salary</span><span class="op">:</span> <span class="dv">2000</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-18" title="18">      <span class="op">},</span></a>
<a class="sourceLine" id="cb6-19" title="19">      <span class="op">{</span></a>
<a class="sourceLine" id="cb6-20" title="20">        <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Alex&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-21" title="21">        <span class="dt">salary</span><span class="op">:</span> <span class="dv">1800</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-22" title="22">      <span class="op">},</span></a>
<a class="sourceLine" id="cb6-23" title="23">    ]<span class="op">,</span></a>
<a class="sourceLine" id="cb6-24" title="24"></a>
<a class="sourceLine" id="cb6-25" title="25">    <span class="dt">internals</span><span class="op">:</span> [</a>
<a class="sourceLine" id="cb6-26" title="26">      <span class="op">{</span></a>
<a class="sourceLine" id="cb6-27" title="27">        <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Jack&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-28" title="28">        <span class="dt">salary</span><span class="op">:</span> <span class="dv">1300</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-29" title="29">      <span class="op">},</span></a>
<a class="sourceLine" id="cb6-30" title="30">    ]<span class="op">,</span></a>
<a class="sourceLine" id="cb6-31" title="31">  <span class="op">},</span></a>
<a class="sourceLine" id="cb6-32" title="32"><span class="op">};</span></a></code></pre>
    </div>
    <p>In other words, a company has departments.</p>
    <ul>
      <li>
        A department may have an array of staff. For instance,
        <code>sales</code> department has 2 employees: John and Alice.
      </li>
      <li>
        Or a department may split into subdepartments, like
        <code>development</code> has two branches: <code>sites</code> and
        <code>internals</code>. Each of them has their own staff.
      </li>
      <li>
        <p>
          It is also possible that when a subdepartment grows, it divides into
          subsubdepartments (or teams).
        </p>
        <p>
          For instance, the <code>sites</code> department in the future may be
          split into teams for <code>siteA</code> and <code>siteB</code>. And
          they, potentially, can split even more. That’s not on the picture,
          just something to have in mind.
        </p>
      </li>
    </ul>
    <p>
      Now let’s say we want a function to get the sum of all salaries. How can
      we do that?
    </p>
    <p>
      An iterative approach is not easy, because the structure is not simple.
      The first idea may be to make a <code>for</code> loop over
      <code>company</code> with nested subloop over 1st level departments. But
      then we need more nested subloops to iterate over the staff in 2nd level
      departments like <code>sites</code>… And then another subloop inside those
      for 3rd level departments that might appear in the future? If we put 3-4
      nested subloops in the code to traverse a single object, it becomes rather
      ugly.
    </p>
    <p>Let’s try recursion.</p>
    <p>
      As we can see, when our function gets a department to sum, there are two
      possible cases:
    </p>
    <ol type="1">
      <li>
        Either it’s a “simple” department with an <em>array</em> of people –
        then we can sum the salaries in a simple loop.
      </li>
      <li>
        Or it’s <em>an object</em> with <code>N</code> subdepartments – then we
        can make <code>N</code> recursive calls to get the sum for each of the
        subdeps and combine the results.
      </li>
    </ol>
    <p>
      The 1st case is the base of recursion, the trivial case, when we get an
      array.
    </p>
    <p>
      The 2nd case when we get an object is the recursive step. A complex task
      is split into subtasks for smaller departments. They may in turn split
      again, but sooner or later the split will finish at (1).
    </p>
    <p>The algorithm is probably even easier to read from the code:</p>
    <p>
      ```js run let company = { // the same object, compressed for brevity
      sales: [{name: ‘John’, salary: 1000}, {name: ‘Alice’, salary: 1600 }],
      development: { sites: [{name: ‘Peter’, salary: 2000}, {name: ‘Alex’,
      salary: 1800 }], internals: [{name: ‘Jack’, salary: 1300}] } };
    </p>
    <p>
      // The function to do the job <em>!</em> function sumSalaries(department)
      { if (Array.isArray(department)) { // case (1) return
      department.reduce((prev, current) =&gt; prev + current.salary, 0); // sum
      the array } else { // case (2) let sum = 0; for (let subdep of
      Object.values(department)) { sum += sumSalaries(subdep); // recursively
      call for subdepartments, sum the results } return sum; } } <em>/!</em>
    </p>
    <p>alert(sumSalaries(company)); // 7700 ```</p>
    <p>
      The code is short and easy to understand (hopefully?). That’s the power of
      recursion. It also works for any level of subdepartment nesting.
    </p>
    <p>Here’s the diagram of calls:</p>
    <figure>
      <img src="recursive-salaries.svg" alt="recursive salaries" />
      <figcaption>recursive salaries</figcaption>
    </figure>
    <p>
      We can easily see the principle: for an object <code>{...}</code> subcalls
      are made, while arrays <code>[...]</code> are the “leaves” of the
      recursion tree, they give immediate result.
    </p>
    <p>Note that the code uses smart features that we’ve covered before:</p>
    <ul>
      <li>
        Method <code>arr.reduce</code> explained in the chapter
        <a href="info:array-methods" class="uri">info:array-methods</a> to get
        the sum of the array.
      </li>
      <li>
        Loop <code>for(val of Object.values(obj))</code> to iterate over object
        values: <code>Object.values</code> returns an array of them.
      </li>
    </ul>
    <h2 id="recursive-structures">Recursive structures</h2>
    <p>
      A recursive (recursively-defined) data structure is a structure that
      replicates itself in parts.
    </p>
    <p>We’ve just seen it in the example of a company structure above.</p>
    <p>A company <em>department</em> is:</p>
    <ul>
      <li>Either an array of people.</li>
      <li>Or an object with <em>departments</em>.</li>
    </ul>
    <p>
      For web-developers there are much better-known examples: HTML and XML
      documents.
    </p>
    <p>In the HTML document, an <em>HTML-tag</em> may contain a list of:</p>
    <ul>
      <li>Text pieces.</li>
      <li>HTML-comments.</li>
      <li>
        Other <em>HTML-tags</em> (that in turn may contain text pieces/comments
        or other tags etc).
      </li>
    </ul>
    <p>That’s once again a recursive definition.</p>
    <p>
      For better understanding, we’ll cover one more recursive structure named
      “Linked list” that might be a better alternative for arrays in some cases.
    </p>
    <h3 id="linked-list">Linked list</h3>
    <p>Imagine, we want to store an ordered list of objects.</p>
    <p>The natural choice would be an array:</p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">let</span> arr <span class="op">=</span> [obj1<span class="op">,</span> obj2<span class="op">,</span> obj3]<span class="op">;</span></a></code></pre>
    </div>
    <p>
      …But there’s a problem with arrays. The “delete element” and “insert
      element” operations are expensive. For instance,
      <code>arr.unshift(obj)</code> operation has to renumber all elements to
      make room for a new <code>obj</code>, and if the array is big, it takes
      time. Same with <code>arr.shift()</code>.
    </p>
    <p>
      The only structural modifications that do not require mass-renumbering are
      those that operate with the end of array: <code>arr.push/pop</code>. So an
      array can be quite slow for big queues, when we have to work with the
      beginning.
    </p>
    <p>
      Alternatively, if we really need fast insertion/deletion, we can choose
      another data structure called a
      <a href="https://en.wikipedia.org/wiki/Linked_list">linked list</a>.
    </p>
    <p>
      The <em>linked list element</em> is recursively defined as an object with:
    </p>
    <ul>
      <li><code>value</code>.</li>
      <li>
        <code>next</code> property referencing the next
        <em>linked list element</em> or <code>null</code> if that’s the end.
      </li>
    </ul>
    <p>For instance:</p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">let</span> list <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="dt">value</span><span class="op">:</span> <span class="dv">1</span><span class="op">,</span></a>
<a class="sourceLine" id="cb8-3" title="3">  <span class="dt">next</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-4" title="4">    <span class="dt">value</span><span class="op">:</span> <span class="dv">2</span><span class="op">,</span></a>
<a class="sourceLine" id="cb8-5" title="5">    <span class="dt">next</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-6" title="6">      <span class="dt">value</span><span class="op">:</span> <span class="dv">3</span><span class="op">,</span></a>
<a class="sourceLine" id="cb8-7" title="7">      <span class="dt">next</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-8" title="8">        <span class="dt">value</span><span class="op">:</span> <span class="dv">4</span><span class="op">,</span></a>
<a class="sourceLine" id="cb8-9" title="9">        <span class="dt">next</span><span class="op">:</span> <span class="kw">null</span><span class="op">,</span></a>
<a class="sourceLine" id="cb8-10" title="10">      <span class="op">},</span></a>
<a class="sourceLine" id="cb8-11" title="11">    <span class="op">},</span></a>
<a class="sourceLine" id="cb8-12" title="12">  <span class="op">},</span></a>
<a class="sourceLine" id="cb8-13" title="13"><span class="op">};</span></a></code></pre>
    </div>
    <p>Graphical representation of the list:</p>
    <figure>
      <img src="linked-list.svg" alt="linked list" />
      <figcaption>linked list</figcaption>
    </figure>
    <p>An alternative code for creation:</p>
    <p>
      <code
        >js no-beautify let list = { value: 1 }; list.next = { value: 2 };
        list.next.next = { value: 3 }; list.next.next.next = { value: 4 };
        list.next.next.next.next = null;</code
      >
    </p>
    <p>
      Here we can even more clearly see that there are multiple objects, each
      one has the <code>value</code> and <code>next</code> pointing to the
      neighbour. The <code>list</code> variable is the first object in the
      chain, so following <code>next</code> pointers from it we can reach any
      element.
    </p>
    <p>
      The list can be easily split into multiple parts and later joined back:
    </p>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">let</span> secondList <span class="op">=</span> <span class="va">list</span>.<span class="va">next</span>.<span class="at">next</span><span class="op">;</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="va">list</span>.<span class="va">next</span>.<span class="at">next</span> <span class="op">=</span> <span class="kw">null</span><span class="op">;</span></a></code></pre>
    </div>
    <figure>
      <img src="linked-list-split.svg" alt="linked list split" />
      <figcaption>linked list split</figcaption>
    </figure>
    <p>To join:</p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="va">list</span>.<span class="va">next</span>.<span class="at">next</span> <span class="op">=</span> secondList<span class="op">;</span></a></code></pre>
    </div>
    <p>And surely we can insert or remove items in any place.</p>
    <p>
      For instance, to prepend a new value, we need to update the head of the
      list:
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">let</span> list <span class="op">=</span> <span class="op">{</span> <span class="dt">value</span><span class="op">:</span> <span class="dv">1</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb11-2" title="2"><span class="va">list</span>.<span class="at">next</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">value</span><span class="op">:</span> <span class="dv">2</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="va">list</span>.<span class="va">next</span>.<span class="at">next</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">value</span><span class="op">:</span> <span class="dv">3</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb11-4" title="4"><span class="va">list</span>.<span class="va">next</span>.<span class="va">next</span>.<span class="at">next</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">value</span><span class="op">:</span> <span class="dv">4</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb11-5" title="5"></a>
<a class="sourceLine" id="cb11-6" title="6"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb11-7" title="7"><span class="co">// prepend the new value to the list</span></a>
<a class="sourceLine" id="cb11-8" title="8">list <span class="op">=</span> <span class="op">{</span> <span class="dt">value</span><span class="op">:</span> <span class="st">&quot;new item&quot;</span><span class="op">,</span> <span class="dt">next</span><span class="op">:</span> list <span class="op">};</span></a>
<a class="sourceLine" id="cb11-9" title="9"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a></code></pre>
    </div>
    <figure>
      <img src="linked-list-0.svg" alt="linked list" />
      <figcaption>linked list</figcaption>
    </figure>
    <p>
      To remove a value from the middle, change <code>next</code> of the
      previous one:
    </p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="va">list</span>.<span class="at">next</span> <span class="op">=</span> <span class="va">list</span>.<span class="va">next</span>.<span class="at">next</span><span class="op">;</span></a></code></pre>
    </div>
    <figure>
      <img src="linked-list-remove-1.svg" alt="linked list" />
      <figcaption>linked list</figcaption>
    </figure>
    <p>
      We made <code>list.next</code> jump over <code>1</code> to value
      <code>2</code>. The value <code>1</code> is now excluded from the chain.
      If it’s not stored anywhere else, it will be automatically removed from
      the memory.
    </p>
    <p>
      Unlike arrays, there’s no mass-renumbering, we can easily rearrange
      elements.
    </p>
    <p>
      Naturally, lists are not always better than arrays. Otherwise everyone
      would use only lists.
    </p>
    <p>
      The main drawback is that we can’t easily access an element by its number.
      In an array that’s easy: <code>arr[n]</code> is a direct reference. But in
      the list we need to start from the first item and go <code>next</code>
      <code>N</code> times to get the Nth element.
    </p>
    <p>
      …But we don’t always need such operations. For instance, when we need a
      queue or even a
      <a href="https://en.wikipedia.org/wiki/Double-ended_queue">deque</a> – the
      ordered structure that must allow very fast adding/removing elements from
      both ends, but access to its middle is not needed.
    </p>
    <p>Lists can be enhanced:</p>
    <ul>
      <li>
        We can add property <code>prev</code> in addition to
        <code>next</code> to reference the previous element, to move back
        easily.
      </li>
      <li>
        We can also add a variable named <code>tail</code> referencing the last
        element of the list (and update it when adding/removing elements from
        the end).
      </li>
      <li>…The data structure may vary according to our needs.</li>
    </ul>
    <h2 id="summary">Summary</h2>
    <p>Terms:</p>
    <ul>
      <li>
        <p>
          <em>Recursion</em> is a programming term that means calling a function
          from itself. Recursive functions can be used to solve tasks in elegant
          ways.
        </p>
        <p>
          When a function calls itself, that’s called a <em>recursion step</em>.
          The <em>basis</em> of recursion is function arguments that make the
          task so simple that the function does not make further calls.
        </p>
      </li>
      <li>
        <p>
          A
          <a href="https://en.wikipedia.org/wiki/Recursive_data_type"
            >recursively-defined</a
          >
          data structure is a data structure that can be defined using itself.
        </p>
        <p>
          For instance, the linked list can be defined as a data structure
          consisting of an object referencing a list (or null).
        </p>
        <div class="sourceCode" id="cb13">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1">list <span class="op">=</span> <span class="op">{</span> value<span class="op">,</span> next <span class="op">-&gt;</span> list <span class="op">}</span></a></code></pre>
        </div>
        <p>
          Trees like HTML elements tree or the department tree from this chapter
          are also naturally recursive: they branch and every branch can have
          other branches.
        </p>
        <p>
          Recursive functions can be used to walk them as we’ve seen in the
          <code>sumSalary</code> example.
        </p>
      </li>
    </ul>
    <p>
      Any recursive function can be rewritten into an iterative one. And that’s
      sometimes required to optimize stuff. But for many tasks a recursive
      solution is fast enough and easier to write and support.
    </p>
  </body>
</html>
